
CoCoALib - Feature #17

implement "binomial" (coefficient) for RingElem

28 Oct 2011 17:00 - Anna Maria Bigatti

Status: Closed Start date: 28 Oct 2011

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 1.00 hour

Target version: CoCoALib-0.99533 Easter14 Spent time: 0.60 hour

Description

in CoCoA-5 it is currently called "Bin"

Related issues:

Related to CoCoA-5 - Design #474: Eliminate package BinRepr In Progress 14 Mar 2014

History

#1 - 08 Nov 2011 10:57 - Anna Maria Bigatti

- Category set to New Function

#2 - 30 Nov 2011 16:00 - John Abbott

Please clarify what exactly you want the function to do, and what values it accepts as args.  For instance is the following allowed:

  PolyRing P = ...;

  RingElem x = indet(P,0);

  cout << binomial(x, 3) << endl;

An analogous call in C4 works and produces  1/6x^3 - 1/2x^2 + 1/3x (in QQ[x]);    

In C4 the function is called "Bin".  In CoCoALib there is a function called binomial (which accepts BigInt args, and presumably MachineInt too).

What should the function do if the second arg is not a non-neg integer?  Is a RingElem which satisfies IsInteger OK?

#3 - 23 May 2013 16:30 - Anna Maria Bigatti

.. and resume/clean up BR.PolyBinRepr_xi

#4 - 26 Mar 2014 18:05 - John Abbott

- Status changed from New to Feedback

- Target version set to CoCoALib-0.99533 Easter14

- % Done changed from 0 to 90

I've made a simple impl (obviously correct, might not be fast).

In answer to my qn in post 2, we've decided to keep it simple (KISS): the 2nd arg must be an integer (or BigInt).

Also made the fn available in C5 (the doc said it was already there!)
#5 - 15 Apr 2014 13:23 - John Abbott

- Status changed from Feedback to Closed

- Assignee set to John Abbott

- % Done changed from 90 to 100

#6 - 17 Apr 2014 09:22 - Anna Maria Bigatti

- Estimated time set to 1.00 h
